#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <stdbool.h>
#include <stdarg.h>
#include <string.h>
#include <uchar.h>
#include <err.h>

#include <sys/types.h>
#include <sys/wait.h>
#include <unistd.h>

#include "memory.h"
#include "dupstr.h"
#include "subproc.h"
#include "uchars.h"

uint32_t HashPublicKeyInfo(void *pCertContext,
                           void *rgbSubjectKeyIdentifier,
                           uint32_t *pcbSubjectKeyIndentifier)
{
    errx(1, "HashPublicKeyInfo NYI");
}

uint32_t ResetAcls(const char16_t **pwzFiles, uint32_t cFiles)
{
    return 0;
}

uint32_t ExtractCabBegin(void)
{
    return 0;
}

uint32_t ExtractCab(const char16_t *wzCabinet, const char16_t *wzExtractDir)
{
    char *cab = ascii(wzCabinet, true), *dir = ascii(wzExtractDir, true);
    fprintf(stderr, "ExtractCab(\"%s\", \"%s\"\n", cab, dir);
    system_argv("cabextract", "-d", dir, cab, cNULL);
    return 0;
}

void ExtractCabFinish(void)
{
}

uint32_t EnumerateCabBegin(void)
{
    return 0;
}

uint32_t EnumerateCab(const char16_t *wzCabinet, void *pfnNotify)
{
    /* FIXME: pfnNotify looks like a fn ptr again */
    fprintf(stderr, "EnumerateCab!\n");
    return 0;
}

void EnumerateCabFinish(void)
{
}
